#include<stdio.h>

int br[11][11],used[10000],pre[10000],from[10000],to[10000],n,k,max,mp;

void fill(void)
{
        int i,j,l;
        for(i=0;i<=10;i++)
        {
                br[0][i]=1;
                br[1][i]=1;
        }
        for(i=2;i<=10;i++)
        {
                for(j=0;j<=10;j++)
                {
                        br[i][j]=0;
                        for(l=0;l<=j;l++) br[i][j]+=br[i-1][l];
                }
        }
}

int code(int a[])
{
        int i,j,result=0;
        for(i=0;i<a[0];i++) result+=br[n-1][k-i];
        int pred=k-a[0];
        for(i=1;i<n-1;i++)
        {
                for(j=0;j<a[i];j++) result+=br[n-i-1][pred-j];
                pred-=a[i];
        }
        return result;
}

void decode(int cod,int a[])
{
        int i,j,c=cod;
        j=0;
        while(c>=br[n-1][k-j])
        {
                c-=br[n-1][k-j];
                j++;
        }
        a[0]=j;
        int pred=k-a[0];
        for(i=1;i<n-1;i++)
        {
                j=0;
                while(c>=br[n-i-1][j])
                {
                        c-=br[n-i-1][j];
                        j++;
                }
                a[i]=j;
                pred-=a[i];
        }
        a[n-1]=pred;
}

int BFS(int s)
{
        int a[10],i,j;
        int q[10000],qe,qf,x;
        qe=qf=0;
        q[qf++]=s;
        used[s]=1;
        while(qe!=qf)
        {
                x=q[qe++];
                used[x]=used[pre[x]]+1;
                if(used[x]>max)
                {
                        max=used[x];
                        mp=x;
                }
                decode(x,a);
                for(i=0;i<n;i++)
                {
                        if(a[i])
                        {
                                a[i]--;
                                for(j=0;j<n;j++)
                                {
                                        if(i!=j)
                                        {
                                                a[j]++;
                                                int cod=code(a);
                                        if(!used[cod])
                                        {
                                                from[cod]=i;
                                                pre[cod]=x;
                                                to[cod]=j;
                                                q[qf++]=cod;
                                        }
                                        a[j]--;
                                        }
                                }
                                a[i]++;
                        }
                }
        }
}

void print(int x,int beg)
{
        if(pre[x]!=beg) print(pre[x],beg);
        printf("%d %d\n",from[x]+1,to[x]+1);
}

int main()
{
        fill();
        scanf("%d%d",&n,&k);
        int a[10],i,c;
        a[0]=k;
        for(i=1;i<n;i++) a[i]=0;
        c=code(a);
        BFS(c);
        printf("%d\n",max);
        print(mp,c);
        return 0;
}
