#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define MAX_N 31
#define MAX_K 11
#define MAX_V 40
#define MAX_VAL 10000000

int mas[MAX_N];
int f[MAX_K][MAX_K];
int ccf[MAX_K];
int values[MAX_K][MAX_V];
int powers[7]={1,2,4,8,16,32,64};
int pos[MAX_N];
int tmp[MAX_K];

int n,m;
int res=MAX_VAL;

void solve(int ind);
int calculate(int fnum);
int calc();

int main(void){
 int i,j;

 //freopen("minval.in","r",stdin);

 clock();

 scanf("%d %d", &m, &n);
 for(i=0; i<m; i++){
  scanf("%d", &ccf[i]);
  for(j=0; j<ccf[i]; j++)
   scanf("%d", &f[i][j]);
  for(j=0; j<powers[ccf[i]]; j++){
   scanf("%d", &values[i][j]);
  }

 }

 solve(0);

 printf("%d\n", res);

 return 0;
}

void solve(int ind){
 int ans;
 int i;

 if(ind>n-1){
  if(clock()/(double)CLOCKS_PER_SEC > 0.75) {printf("%d\n", res); exit(0);}
  ans=calc();
  if(ans<res) res=ans;
  return;
 }

 pos[ind]=0;
 solve(ind+1);
 pos[ind]=1;
 solve(ind+1);

}

int calc(){
 int i;
 int ans=0;

 for(i=0; i<m; i++)
  ans+=calculate(i);

 return ans;
}

int calculate(int fnum){
 int cc=0;
 int mul=1;
 int r=0;
 int i;

 while(cc<ccf[fnum]){
  tmp[cc]=pos[f[fnum][cc]-1];
  cc++;
 }

 for(i=cc-1; i>=0; i--){
  r+=tmp[i]*mul;
  mul*=2;
 }

 return values[fnum][r];
}

