#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define IN  "paths.in"
#define MAX_N 100010

struct TTree{
 int length;
 int node;
 struct TTree *next;
};

struct TNode{
 int maxd;
 int smaxd;
};

struct TTree *mas[MAX_N];
int          br_nasl[MAX_N];
int          parent[MAX_N];
int          list[MAX_N];
int          maximum[MAX_N];
int          used[MAX_N];

int n,m;
int cur;

int max(int aa, int bb){
 return (aa>bb) ? aa:bb;
}

void addTree(struct TTree **stack, int val, int len);
void DFS(int node, int depth);

int main(void){
 int i,j;
 int a,b,d;

// freopen(IN,"r",stdin);

 memset(parent,0,sizeof(parent));
 memset(br_nasl,0,sizeof(br_nasl));

 scanf("%d %d", &n, &m);

 for(i=0; i<=n; i++) mas[i]=NULL;

 for(i=0; i<m; i++){
  scanf("%d %d %d", &a, &b, &d);
  addTree(&mas[a], b,d);
  addTree(&mas[b], a,d);
 }

 parent[1]=-1;

 for(i=1; i<=n; i++){
  memset(used,0,sizeof(used));
  cur=i;
  DFS(i,0);
 }

 for(i=1; i<=n; i++){
  printf("%d\n", maximum[i]);
 }

 /*DFS(1);

 for(i=1; i<=n; i++){
  if(br_nasl[i]==0) list[count++]=i;
 }
 */

 return 0;
}

void addTree(struct TTree **stack, int val, int len){
 struct TTree *tmp;

 tmp=(struct TTree *)malloc(sizeof(struct TTree));
 tmp->node=val;
 tmp->length=len;
 tmp->next=*stack;
 *stack=tmp;

}

void DFS(int node, int depth){
 int i;
 struct TTree *tmp;

 used[node]=1;
 tmp=mas[node];

 maximum[cur]=max(depth,maximum[cur]);

 while(tmp!=NULL){
  if(!used[tmp->node]){
   br_nasl[node]++;
   parent[tmp->node]=node;
   DFS(tmp->node,depth+tmp->length);
  }
  tmp=tmp->next;
 }

}

