#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define MAXN 400000
#define MAX 11000000001

struct reb
{
  unsigned int a:17;
  unsigned int b:17;
  unsigned int c:17;
}rb[MAXN];

long long min[100000];
int l[100001];
int n,m;

struct heap
{
  int p;
  long long d;
}hp[100000],t;
int hs;
int pos[100000];

int comp(const void *a,const void *b)
{
  struct reb *a1,*b1;
  a1=(struct reb *)a;
  b1=(struct reb *)b;

  if(a1->a != b1->a) return a1->a - b1->a;
  return a1->b - b1->b;
}

void printsol()
{
  int i;
  for(i=0;i<n;i++) printf("%lld\n",min[i]);
}


void mu(int a);
void md(int a);
void add(int a);
void djh(int a);

int main()
{
  register int i,j;

//  freopen("paths.in","r",stdin);
//  freopen("paths.out","w",stdout);

  scanf("%d %d",&n,&m);
  m+=m;
  for(i=0;i<m;i+=2)
  {
    unsigned int x,y,z;
    scanf("%u %u %u",&x,&y,&z);
    rb[i].a=(x-1);
    rb[i].b=(y-1);
    rb[i].c=z;

    rb[i+1].a=(y-1);
    rb[i+1].b=(x-1);
    rb[i+1].c=z;
  }

  qsort(rb,m,sizeof(struct reb),comp);

  for(i=1;i<m;i++)
  {
    if(rb[i].a != rb[i-1].a) l[rb[i].a]=i;
  }
  l[n]=m;

//  for(i=0;i<m;i++) printf("%d %d %d\n",rb[i].a,rb[i].b,rb[i].c);
//  for(i=0;i<=n;i++) printf("%d\n",l[i]);

  // da sloja da mi spira vremeto kogato izteche
  for(i=0;i<n;i++)
  {
    djh(i);

    if((float)((float)clock()/(float)CLOCKS_PER_SEC) > 2.8)
    {
      printsol();
      exit(0);
    }
  }
  printsol();

  return 0;
}

void mu(int a)
{
  long long d;
  int pl;

  pl=pos[a];
  d=hp[pl].d;

  while(pl && hp[(pl-1)/2].d>d)
  {
    hp[pl]=hp[(pl-1)/2];
    pl=(pl-1)/2;
  }
  hp[pl].d=d;
  hp[pl].p=a;
  pos[a]=pl;
}

void md(int a)
{
  long long d;
  int pl;

  pl=pos[a];
  d=hp[pl].d;

  while(((pl*2+1)<hs && hp[pl*2+1].d<d) || ((pl*2+2)<hs && hp[pl*2+2].d<d))
  {
    pl=(pl*2+1);
    if((pl+1)<hs && hp[pl].d>hp[pl+1].d) pl++;
    hp[(pl-1)/2]=hp[pl];
  }
  hp[pl].d=d;
  hp[pl].p=a;
  pos[a]=pl;
}

void add(int a)
{
  hp[hs].p=a;
  hp[hs].d=MAX;
  pos[a]=hs;
  mu(hs++);
}

void djh(int a)
{
  register int i,j;
  int k;
  long long m[100000];
  int u[100000];

  hs=0;
  for(i=0;i<n;i++)
  {
    add(i);
    u[i]=0;
  }
  m[a]=0;
  u[a]=1;

  for(i=0,k=a;i<n;i++)
  {
     for(j=l[k];j<l[k+1];j++)
     {
       if(!u[rb[j].b] && hp[pos[rb[j].b]].d>(m[k]+rb[j].c))
       {
         hp[pos[rb[j].b]].d=(m[k]+rb[j].c);
         mu(rb[j].b);
       }
     }
     if(hp[0].d==MAX) break;
     m[hp[0].p]=hp[0].d;
     u[hp[0].p]=1;
     k=hp[0].p;

     hp[0].d=MAX;
     md(k);
  }

  for(i=0;i<n;i++)
  {
    if(m[i]>min[i]) min[i]=m[i];
  }
}

