#include <stdio.h>
#include <time.h>

#define MAXN 31
#define MAXM 10
#define MAXS 100

int n,m;
int val[MAXM][MAXS];
int dep_sz[MAXM];
int deps[MAXM][MAXN];
int curr[MAXN];
int min = 0x7FFFFFFF;
int TIME_LIMIT = (CLOCKS_PER_SEC*9) / 10;

void Init()
  {
    int i,j;

//    freopen("minval.in","rt",stdin);
    scanf("%d%d",&m,&n);

    for (i = 0;i < m;i++)
      {
        scanf("%d",&dep_sz[i]);
        for (j = 0;j < dep_sz[i];j++)
          {
            scanf("%d",&deps[i][j]);
            deps[i][j]--;
          }

        for (j = 0;j < (1 << dep_sz[i]);j++)
          scanf("%d",&val[i][j]);
      }
  }

void GenNext()
  {
    int i = 0;
    curr[0]++;
    while (curr[i] == 2)
      {
        curr[i] = 0;
        curr[i + 1]++;
        i++;
      }
  }

void Check()
  {
    int i,j;
    int index;
    int sum = 0;

    for (i = 0;i < m;i++)
      {
        index = 0;
        for (j = dep_sz[i] - 1;j >= 0;j--)
          if (curr[deps[i][j]]) index += (1 << (dep_sz[i] - j - 1));

        sum += val[i][index];
      }
    if (sum < min) min = sum;
  }

void Solve()
  {
    memset(curr,0,sizeof(curr));
    do
      {
        Check();
        GenNext();
      }
    while (!curr[n] && clock() < TIME_LIMIT);
  }

void Output()
  {
    printf("%d\n",min);
  }

int main()
  {
    Init();
    Solve();
    Output();
    return 0;
  }
