#include <ctime>
#include <iostream>

int cups[10];
int cup_names[10];
int n; int k;

inline void swap(const int& a, const int& b)
{
	if (a == b) return;
	cups[a] ^= cups[b] ^= cups[a] ^= cups[b];
	cup_names[a] ^= cup_names[b] ^= cup_names[a] ^= cup_names[b];
}

int move_marble()
{
	int i = 0;
	while (!cups[i]) i++;
	cups[i+1]++;
	cups[i]--;
	std::cout << cup_names[i] << ' ' << cup_names[i+1] << '\n';
	return i;
}

int main()
{
	std::cin >> n >> k;
	for (int i = 0; i < n; i++)
	{
		cup_names[i] = i+1;
		cups[i] = 0;
	}

	cups[0] = k;

	time_t t1, t0;
	
	std::time(&t0);
	std::time(&t1);
	while (cups[n-1] < k && std::difftime(t1, t0) < 2.99)
		{swap(0, move_marble()); std::time(&t1);}

	return 0;
}
