#include <stdio.h>

#define MAXN            100010
#define MAXM            1000100

typedef struct s1
{
  int to;
  int val;
} trebro;

int n,m;
int rebra[MAXM][3];
trebro *nasl[MAXN];
int brn[MAXN];
int dist[MAXN];
int vis[MAXN];
int maxv;

void input()
{
  int i;
  int a,b,c;

  scanf("%d %d",&n,&m);

  for(i=0;i<=n;i++)
    brn[i] = 0;

  for(i=0;i<m;i++)
  {
    scanf("%d %d %d",&a,&b,&c);
    rebra[i][0] = a;
    rebra[i][1] = b;
    rebra[i][2] = c;
    brn[a]++;
    brn[b]++;
  }

  for(i=1;i<=n;i++)
  {
    nasl[i] = (trebro*)malloc((brn[i]+1)*sizeof(trebro));
    brn[i] = 0;
  }

  for(i=0;i<m;i++)
  {
    a = rebra[i][0];
    b = rebra[i][1];
    c = rebra[i][2];

    nasl[a][brn[a]].to = b;
    nasl[b][brn[b]].to = a;
    nasl[a][brn[a]++].val = c;
    nasl[b][brn[b]++].val = c;
  }
}

void DFS(int num)
{
  int i;

  vis[num] = 1;
  if(dist[num]>maxv)
    maxv = dist[num];

  for(i=0;i<brn[num];i++)
  {
    if(!vis[nasl[num][i].to])
    {
      dist[nasl[num][i].to] = dist[num]+nasl[num][i].val;
      DFS(nasl[num][i].to);
    }
  }

}

void solve()
{
  int i,i2;


  for(i=1;i<=n;i++)
  {
    for(i2=1;i2<=n;i2++)
      vis[i2] = 0;

    dist[i] = 0;
    maxv = 0;

    DFS(i);

    printf("%d\n",maxv);
  }
}

int main()
{
//  freopen("pathst.txt","r",stdin);

  input();
  solve();

  return 0;
}

