#include <iostream.h>
#include <values.h>
#define MAXLONGINT 150000
const long int maxn=100000;
const long int maxi=2000;
unsigned long int D[maxn];
unsigned long int maxc=0;

unsigned long int n;

 struct Node
  {
   unsigned long int *a;
   unsigned long int *b;
   unsigned long int top;
  }node[maxn];


 void init()
  {
   unsigned long int i,j,k,m;
    cin>>n>>m;
    for(i=0;i<n;i++)
     {
      node[i].a=new unsigned long int[maxi];
      node[i].b=new unsigned long int[maxi];
      node[i].top=0;
     }
    for(k=0;k<m;k++)
     {
      int a,b,c;
      cin>>a>>b>>c;
      a--;b--;
      int top=node[a].top;
      node[a].a[top]=b;
      node[a].b[top]=c;
      node[a].top++;
      top=node[b].top;
      node[b].a[top]=a;
      node[b].b[top]=c;
      node[b].top++;
     }
  }


 void dijkstra(int s)
  {
    maxc=0;
   int T[maxn];
   unsigned long int i,k;
   long int j;
    for(i=0;i<n;i++)
     {
      T[i]=1;
      D[i]=MAXLONGINT;
     }
   for(i=0;i<node[s].top;i++)
     D[node[s].a[i]]=node[s].b[i];
   T[s]=0;
    while(1)
     {
      unsigned long int di=MAXLONGINT;
      j=-1;
        for(i=0;i<node[s].top;i++)
         if(T[node[s].a[i]]&&di>node[s].b[i])
           {
            j=node[s].a[i];
            di=node[s].b[i];
           }
        if(j==-1) break;
        T[j]=0;
         for(i=0;i<node[j].top;i++)
          if(T[node[j].a[i]]&&D[node[j].a[i]]>D[j]+node[j].b[i])
            {
             D[node[j].a[i]]=D[j]+node[j].b[i];
//             if(maxc<D[node[j].a[i]]) maxc=D[node[j].a[i]];
            }
     }
 for(i=0;i<n;i++)
  if(D[i]>maxc&&D[i]<MAXLONGINT)
    maxc=D[i];

  }

 void solve()
  {
   unsigned long int i;
    for(i=0;i<n;i++)
      {
       dijkstra(i);
       cout<<maxc<<endl;
      }

  }

 void deinit()
  {
    unsigned long int i;
     for(i=0;i<n;i++)
      {
      delete node[i].a;
      delete node[i].b;
      }
  }

 void main()
  {
   init();
   solve();
   deinit();
  }
