program pict;

const
	MAXN					= 1500;

type
	TPicture				= record
		a, b				: Real;
	end;

var
	p					: Array [1 .. MAXN] of TPicture;
	N, i					: Integer;
	min, W					: Real;

procedure readInput;
begin
	readln(N, W);
	for i := 1 to N do
		readln(p[i].a, p[i].b);	
end;

procedure go(i: Integer; fl, cl, left: Real);
begin
	if (i = N + 1) then begin
		if (cl < min) then
			min := cl;
		Exit;
	end;
	if (left >= p[i].a) then begin
		if (fl + p[i].b > cl) then
			go(i + 1, fl, fl + p[i].b, left - p[i].a)
		else
			go(i + 1, fl, cl, left - p[i].a);
	end else if (left >= p[i].b) then begin
		if (fl + p[i].a > cl) then
			go(i + 1, fl, p[i].a + fl, left - p[i].b)
		else
			go(i + 1, fl, cl, left - p[i].b);
	end;
	if (W >= p[i].a) then
		go(i + 1, cl, cl + p[i].b, W - p[i].a);
	if (W >= p[i].b) then
		go(i + 1, cl, cl + p[i].a, W - p[i].b);
end;

procedure Solve;
var
	i						: Integer;
	left, fl, cl					: Real;
	acTurn						: Boolean;
begin
	min := 9999999;
	if (N <= 14) then begin
		go(2, 0.000000, p[1].a, W - p[1].b);
		go(2, 0.000000, p[1].b, W - p[1].a);
	end else begin
		left := W;
		fl := 0.000000;
		cl := 0.000000;
		for i := 1 to N do
			if (left >= p[i].a) then begin
				left := left - p[i].a;
				if (fl + p[i].b >= cl) then
					cl := fl + p[i].b;
			end else begin
				left := W - p[i].a;
				fl := cl;
				cl := fl + p[i].b;
			end;
		if (min > cl) then
			min := cl;
		left := W;
		fl := 0.000000;
		cl := 0.000000;
		for i := 1 to N do
			if (left >= p[i].b) then begin
				left := left - p[i].b;
				if (fl + p[i].a >= cl) then
					cl := fl + p[i].a;
			end else begin
				left := W - p[i].b;
				fl := cl;
				cl := fl + p[i].a;
			end;
		if (min > cl) then
			min := cl;
		left := W;
		fl := 0.000000;
		cl := 0.000000;
		for i := 1 to N do begin
			if (p[i].a < p[i].b) then begin
				if (left >= p[i].a) then begin
					left := left - p[i].a;
					if (fl + p[i].b >= cl) then
						cl := fl + p[i].b;
				end else begin
					left := W - p[i].a;
					fl := cl;
					cl := fl + p[i].b;
				end;
			end else begin
				if (left >= p[i].b) then begin
					left := left - p[i].b;
					if (fl + p[i].a >= cl) then
						cl := fl + p[i].a;
				end else begin
					left := W - p[i].b;
					fl := cl;
					cl := fl + p[i].a;
				end;
			end;
		end;
		if (min > cl) then
			min := cl;
		left := W;
		fl := 0.000000;
		cl := 0.000000;
		for i := 1 to N do begin
			if (p[i].a > p[i].b) then begin
				if (left >= p[i].a) then begin
					left := left - p[i].a;
					if (fl + p[i].b >= cl) then
						cl := fl + p[i].b;
				end else begin
					left := W - p[i].a;
					fl := cl;
					cl := fl + p[i].b;
				end;
			end else begin
				if (left >= p[i].b) then begin
					left := left - p[i].b;
					if (fl + p[i].a >= cl) then
						cl := fl + p[i].a;
				end else begin
					left := W - p[i].b;
					fl := cl;
					cl := fl + p[i].a;
				end;
			end;
		end;
		if (min > cl) then
			min := cl;
		left := W;
		fl := 0.000000;
		cl := 0.000000;
		acTurn := True;
		for i := 1 to N do begin
			if (acTurn) and (p[i].a < p[i].b) then begin
				if (left >= p[i].b) then begin
					left := left - p[i].b;
					if (fl + p[i].a >= cl) then
						cl := fl + p[i].a;
				end else begin
					left := W - p[i].b;
					fl := cl;
					cl := fl + p[i].a;
				end;
			end else if (acTurn) and (p[i].a > p[i].b) then begin
				if (left >= p[i].a) then begin
					left := left - p[i].a;
					if (fl + p[i].b >= cl) then
						cl := fl + p[i].b;
				end else begin
					left := W - p[i].a;
					fl := cl;
					cl := fl + p[i].b;
				end;
			end else if (not acTurn) and (p[i].a < p[i].b) then begin
				if (left >= p[i].a) then begin
					left := left - p[i].a;
					if (fl + p[i].b >= cl) then
						cl := fl + p[i].b;
				end else begin
					left := W - p[i].a;
					fl := cl;
					cl := fl + p[i].b;
				end;
			end else begin
				if (left >= p[i].b) then begin
					left := left - p[i].b;
					if (fl + p[i].a >= cl) then
						cl := fl + p[i].a;
				end else begin
					left := W - p[i].b;
					fl := cl;
					cl := fl + p[i].a;
				end;
			end;
			acTurn := not acTurn;
		end;
		if (min > cl) then
			min := cl;
		left := W;
		fl := 0.000000;
		cl := 0.000000;
		acTurn := False;
		for i := 1 to N do begin
			if (acTurn) and (p[i].a < p[i].b) then begin
				if (left >= p[i].b) then begin
					left := left - p[i].b;
					if (fl + p[i].a >= cl) then
						cl := fl + p[i].a;
				end else begin
					left := W - p[i].b;
					fl := cl;
					cl := fl + p[i].a;
				end;
			end else if (acTurn) and (p[i].a > p[i].b) then begin
				if (left >= p[i].a) then begin
					left := left - p[i].a;
					if (fl + p[i].b >= cl) then
						cl := fl + p[i].b;
				end else begin
					left := W - p[i].a;
					fl := cl;
					cl := fl + p[i].b;
				end;
			end else if (not acTurn) and (p[i].a < p[i].b) then begin
				if (left >= p[i].a) then begin
					left := left - p[i].a;
					if (fl + p[i].b >= cl) then
						cl := fl + p[i].b;
				end else begin
					left := W - p[i].a;
					fl := cl;
					cl := fl + p[i].b;
				end;
			end else begin
				if (left >= p[i].b) then begin
					left := left - p[i].b;
					if (fl + p[i].a >= cl) then
						cl := fl + p[i].a;
				end else begin
					left := W - p[i].b;
					fl := cl;
					cl := fl + p[i].a;
				end;
			end;
			acTurn := not acTurn;
		end;
		if (min > cl) then
			min := cl;
	end;
end;

procedure writeOutput;
begin
	writeln(min:1:6);
end;

begin
	readInput;
	Solve;
	writeOutput;
end.
