#include <fstream.h>
#include <iomanip.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

const double EPS = 0.00000001;

char used[ 1501 ];
int n;
double w;

double rows[ 1000 ];
double rowsh[ 1000 ];

struct pict
{
 double a;
 double b;
} pics[ 1501 ];


void init( )
{
 int i;

// ifstream fin( "pict.in" );
 cin>>n>>w;
 double t;

 for ( i=1; i<=n; i++ )
 {
	 cin>>pics[ i ].a>>pics[ i ].b;

	 if ( pics[ i ].a - pics[ i ].b > EPS )
	 {
		t = pics[ i ].a;
		pics[ i ].a =  pics[ i ].b;
		pics[ i ].b = t;
	 }
 }


 memset(	used, 0, sizeof( used ) );
}


int cmp( const void* a, const void* b )
{
	pict* p = (pict*) a;
	pict* q = (pict*) b;

	if ( p->a - q->a > EPS  )
	  return 1;

	if ( p->a - q->a < 0 )
	  return -1;

	if ( p->a - q->a < EPS )
	{
		if ( p->b - q->b > EPS  )
		  return 1;

		if ( p->b - q->b < 0 )
		  return -1;
	}

	return 0;
}

double max( double a, double b )
{
 	return ( a - b > 0 ) ? a : b;
}

double fillrow(	double w, int row, double min )
{
	double w1 = w;
	int i;

   double res = min;

	if ( w<EPS )
	{
     rows[ row ] = 0.0;
     return  res;
	}


	for ( i=1; i<=n; i++ )
		if ( !used[ i ] )
		  break;

	if ( i<=n )
	{
		if ( w1 - pics[ i ].b  >= EPS  )
		{
       	used[ i ] = 1;
         w1 -= pics[ i ].b;
       	res =  fillrow( w1, row, max( min, pics[ i ].a ) );
      }
      else
		if ( w1 - pics[ i ].a >= EPS && pics[ i ].b <= min )
      {
         used[ i ] = 1;
         w1 -= pics[ i ].a;
         res = fillrow( w1, row, max( min, pics[ i ].b ) );
      }
		else
   	if ( w1 - pics[ i ].a >= EPS && min == 0 )
      {
        used[ i ] = 1;
        w1 -= pics[ i ].a;
        res =  ( fillrow( w1, row, pics[ i ].b ) );
      }
   	else
      if ( w1 >= pics[ i ].a && pics[ i ].b - min <= pics[ i ].a )
		{
       	used[ i ] = 1;
	      w1 -= pics[ i ].a;
	      res =  ( fillrow( w1, row, pics[ i ].b ) );
      }
	}

	rows[ row ] = w1;
   rowsh[ row ] = min;
	return res;
}

void solve( )
{
 	double min = 0;
	qsort( pics+1,	n, sizeof( pict ), cmp );

	int i=1, j, k;
	double w1 = w;

	int row = 0;

	while ( i<=n )
	{
		for ( i=1; i<=n; i++ )
			if ( !used[ i ] )
			  break;

		if ( i<=n )
		{
       double s, t=9999;
       s = fillrow( w, row, 0 );

		 min += s < t ? s : t;
		 row++;
		}
	}

	int x = min;
	int e=0;
	while ( x > 0 )
	{  e++; x/=10; }

	cout.flags( 256 );
	cout<<setprecision( e+6 )<<min<<endl;
}


void main ( )
{
	init( );
	solve( );
}
