#include <stdio.h>

#define val(a) (-(a).w)
#define INF	1000000
#define eps (0.000001)
#define swap(a,b) {t=a;a=b;b=t;}
#define min(a,b) ((a)<(b)?(a):(b))
#define max(a,b) ((a)>(b)?(a):(b))

struct pic{float h, w;};

struct pic pics[2048];
int N;
float W;

struct pic heap[1500];
int hsize=1;

int empty(){return hsize==1;}

void push(struct pic a){
	struct pic t;
    int pos=hsize++;
    heap[pos]=a;
    while(pos!=1&&val(heap[pos])>val(heap[pos/2])){
    	swap(heap[pos], heap[pos/2]);
    	pos/=2;
    }
}

struct pic pop(){
	int pos=1;
	struct pic res=heap[pos], t;
    heap[pos]=heap[--hsize];
    while(pos*2<hsize&&(val(heap[pos])<val(heap[pos*2])||
    					val(heap[pos])<val(heap[pos*2+1]))){
    	if(val(heap[pos*2])>val(heap[pos*2+1])){
        	swap(heap[pos], heap[pos*2]);
            pos*=2;
    	}
        else {
			swap(heap[pos], heap[pos*2+1]);
            pos=pos*2+1;
    	}
    }
    return res;
}

float minh[1501][1501];
double dyn[1501][1501];

double f(int a, int b){
	int i;
    double res;
    /*if(a>b) return -INF;*/
    if(dyn[a][b]==-1){
    	dyn[a][b]=INF;
    	for(i=a;i<b&&minh[a][i]!=INF;i++){
        	res=minh[a][i]+f(i+1,b);
            if(dyn[a][b]>res) dyn[a][b]=res;
    	}
        if(dyn[a][b]>minh[a][b]) dyn[a][b]=minh[a][b];
    }
    return dyn[a][b];
}


int main(){
	struct pic tp;
    int i, j;
    float t, cminh, cw;
    //freopen("pict.in", "r", stdin);
    scanf("%d%f", &N, &W);
    /*printf("%d %f\n", N, W);/**/
    for(i=0;i<N;i++){
    	scanf("%f%f", &pics[i].w, &pics[i].h);
        if(pics[i].w<pics[i].h){
             t=pics[i].w;pics[i].w=pics[i].h;pics[i].h=t;
        }
    }
    /*for(i=0;i<N;i++) printf("%f %f\n", pics[i].w, pics[i].h);/**/
    for(i=0;i<N;i++) for(j=0;j<N;j++) {dyn[i][j]=-1;minh[i][j]=INF;}
    /*printf("heap test\n");
    for(i=0;i<10;i++) {
    	tp.w=rand()%99;
        tp.h=rand()%99;
        push(tp);
    }
    while(!empty()){tp=pop();printf("%f %f\n", tp.w, tp.h);}
    printf("END heap test\n"); /**/
    for(i=0;i<N;i++){
    	hsize=1;
    	cminh=cw=0;
        for(j=i;j<N;j++){
            push(pics[j]);
            cw+=pics[j].w;
            cminh=max(cminh, pics[j].h);
        	while(cw>W&&!empty()){
                 tp=pop();
                 cw-=tp.w;
				 cw+=tp.h;
                 cminh=tp.w;
        	}
            if(cw>W) break;
            minh[i][j]=cminh;
        }
    }
    /*for(i=0;i<N;i++) {for(j=0;j<N;j++) printf("%f ", minh[i][j]);printf("\n");}
    printf("dyn:\n");
    for(i=0;i<N;i++) {for(j=0;j<N;j++) printf("%lf ", f(i,j));printf("\n");}
    printf("%lf\n", f(0,1));
	printf("RESULT:\n");*/
    printf("%f\n", f(0,N-1));

    return 0;
}
