Const
  InFile = 'Pict.Inp';
  MaxN = 1510;
  MinValue = -10000;
Type
  Pictures = Array[1..MaxN] of Record x,y : Real End;

Var
  Pic : Pictures;

  N,i : Integer;
  W : Real;

Procedure Swap(Var p,q : Real);
Var
  Sm : Real;
Begin
  Sm:=p; p:=q; q:=Sm
End;

Procedure Input;
Var
  F : Text;
  g1,g2 : Real;
Begin
  Assign(F,InFile); Reset(F);
  ReadLn(F,N,W);
  For i:=1 to N do
    With Pic[i] do
      Begin
        ReadLn(F,g1,g2);
        If g1 > g2 Then Swap(g1,g2);
        x:=g1; y:=g2
    End;
  Close(F)
End;

Procedure Solve;
Var
  Best,Remain,Min : Real;
Begin
  Best:=0; Remain:=W;
  For i:=1 to N do
    With Pic[i] do
      Begin
        Min:=MinValue;
        If y < Remain Then
          Begin
            If x > Min Then Min:=x;
            Remain:=Remain-y;
          End
        Else Begin Best:=Best-Min; Remain:=W End;
      End;
  WriteLn(Best:0:6)
End;

Begin
  Input;
  Solve
End.
