#include <algorithm>
#include <cstdio>

using namespace std;

const int MAXN = 1500;
const long long int INF = 10000000000000000ll;

int N;
int W;
int h[MAXN + 1];
int w[MAXN + 1];
int min_str[MAXN + 1];
int max_str[MAXN + 1];
long long int bw[MAXN + 1];
long long int ww[MAXN + 1];
long long int cache[MAXN + 1];

inline void readWidth(int& x) {
	/*
	int a;
        char c;
        int b;
        scanf("%d%c%d", &a, &c, &b);
        x = a * 1000000 + b;
        */
        double ld;
        scanf("%lf", &ld);
        //printf("ld=%f\n", ld);
        double y = static_cast<long double>(1000000) * ld;
        //printf("y=%f\n", y);
        x = y;
        //printf("x=%d\n", x);
}

inline long long int worstWidth(int i, int j) {//!
	return ww[j] = ww[i - 1];
}

long long int minh(int i, int j, long long int wl) {
	//printf("minh(i=%d, j=%d, wl=%lld)\n", i, j, wl);
        /*
        if (i == j) {
        	long long int result = INF;
                if (w[i] < wl) {
                	long long int tmp = h[i];
                        if (tmp < result) result = tmp;
                }
                if (h[i] < wl) {
                	long long int tmp = w[i];
                        if (tmp < result) result = tmp;
                }
        }
        */
        /*
        if (worstWidth(i, j) <= wl) {
        	long long int result = 0;
                for (int k = i; k <= j; k++) {
                	if (min_str[k] > result) result = min_str[k];
                }
                return result;
        }
        */
	if (j + 1 == i) return 0;
        long long int result = INF;
        if (w[j] <= wl) {
        	long long int tmp = max(minh(i, j - 1, wl - w[j]), static_cast<long long int>(h[j]));
                if (tmp < result) result = tmp;
        }
        if (h[j] == w[j]) goto kraj;
        if (h[j] <= wl) {
        	long long int tmp = max(minh(i, j - 1, wl - h[j]), static_cast<long long int>(w[j]));
                if (tmp < result) result = tmp;
        }
        kraj:
        return result;
}

inline long long int bestWidth(int i, int j) {//!
	return bw[j] - bw[i - 1];
}

inline int findMaxAllowed(int ind) {//!
	int j;
	for (j = ind; j >= 1/*//!*/; j--) {
        	if (bestWidth(j, ind) > W) break;
        }
        return ind - j;
}

long long int H(int ind) {
	if (cache[ind] >= 0) {
        	return cache[ind];
        }
        if (ind == 0) return cache[ind] = 0;
        long long int result = INF;
        int ma = findMaxAllowed(ind);
        for (int k = 1; k <= ma; k++) {
        	long long int tmp = H(ind - k) + minh(ind - k + 1, ind, W);
                //printf("tmp=%lld", tmp);
                if (tmp < result) result = tmp;
        }
        return cache[ind] = result;
}

void printWidth(long long int x) {
        long long int a = x / 1000000;
        long long int b = x % 1000000;
        printf("%lld.%06lld", a, b);
}

int main() {
        /*
	int a;
        int b;
        char c;
        scanf("%d%c%d", &a, &c, &b);
        printf("a=%d\n", a);
        printf("b=%d\n", b);
        readWidth(a);
        printf("a=%d\n", a);
        */
        scanf("%d", &N);
        readWidth(W);
        for (int i = 1; i <= N; i++) {
        	readWidth(h[i]);
        	readWidth(w[i]);
        }
        for (int i = 1; i <= N; i++) {
        	min_str[i] = min(h[i], w[i]);
        	max_str[i] = max(h[i], w[i]);
        }
        bw[0] = 0;
        ww[0] = 0;
        long long int bw_sum = 0;
        long long int ww_sum = 0;
        for (int i = 1; i <= N; i++) {
        	bw_sum += min_str[i];
                bw[i] = bw_sum;
                ww_sum += max_str[i];
                ww[i] = ww_sum;
        }

        for (int i = 0; i <= N; i++) {
        	cache[i] = -1;
        }
        long long int ans = H(N);
        printWidth(ans);
        printf("\n");
        //printf("ans=%lld\n", ans);
}
