#include <stdio.h>

#define N 32
#define M 16
#define K 8

int n, m;
int fc[M];
int fp[M][K];
int fv[M][1<<K];

int pp[N];
int u[N];

void read_data() {
	int i, j;

        /*freopen("minval.in", "r", stdin);*/
	scanf("%d%d", &m, &n);
        for (i = 0; i < m; i++) {
        	scanf("%d", &fc[i]);
                for (j = 0; j < fc[i]; j++) {
                                scanf("%d", &fp[i][j]);
                        u[fp[i][j]]++;
                }
                for (j = 0; j < (1<<fc[i]); j++)
                	scanf("%d", &fv[i][j]);
        }
}

void fix_par(int a) {
	int i, j;
        int k, k1;

        for (i = 0; i < m; i++) {
        	for (j = 0; j < fc[i]; j++)
                	if (fp[i][j] == a)
                        	break;
                if (j < fc[i])
                	break;
        }

        for (k = 0; k < (1<<fc[i]); k++) {
        	k1 = k^(1<<(fc[i]-j-1));
                if (fv[i][k] > fv[i][k1])
                	fv[i][k] = fv[i][k1];
        }
}

int calc_fun(int f, int p) {
        int i;
        int k;

        k = 0;
        for (i = 0; i < fc[f]; i++) {
        	k <<= 1;
                if (u[fp[f][i]] == 2)
			k += (p/pp[fp[f][i]])%2;
        }
        return fv[f][k];
}

void solve() {
	int i, j;
        int c;
        int r;
        int br;

        c = 1;
        for (i = 1; i <= n; i++) {
        	if (u[i] == 1)
                	fix_par(i);
                if (u[i] == 2) {
                        pp[i] = c;
                        c *= 2;
                }
        }

        br = 1000000;
        for (i = 0; i < c; i++) {
        	r = 0;
        	for (j = 0; j < m; j++)
                	r += calc_fun(j, i);
                if (r < br)
                	br = r;
        }
        printf("%d\n", br);
}

int main() {
	read_data();
        solve();
	return 0;
}
