program path;
type pstr = ^dstr;
     dstr = record
             dst : longint;
             size: longint;
             link: pstr;
            end;
     ptail = ^dtail;
     dtail = record
              data:longint;
              link:ptail;
             end;
var map:array[1..10000] of pstr;
    tail,ftail,ltail:ptail;
    ndx:array[1..10000] of byte;
    a,b,c,i,i1,m,n,k,maxi:longint;
    max:qword;
    point:longint;
    str,hlp:pstr;
procedure init;
 begin
  readln(n,m);
  for i:=1 to m do
   begin
    readln(a,b,c);
    new(str);
    str^.dst:=a;
    str^.size:=c;
    str^.link:=map[b];
    map[b]:=str;
    new(str);
    str^.dst:=b;
    str^.size:=c;
    str^.link:=map[a];
    map[a]:=str;
   end;
  end;

procedure addtail(el:longint);
 begin
  new(tail);
  if ftail=nil then ftail:=tail;
  tail^.data:=el;
  tail^.link:=nil;
  tail^.link:=ltail;
  ltail:=tail;
  ndx[el]:=1;
 end;
procedure gettail(var el:longint);
var scrap:ptail;
 begin
  el:=ftail^.data;
  scrap:=ftail;
  ftail:=scrap^.link;
  if ftail=nil then ltail:=nil;
  dispose(scrap);
  ndx[el]:=0;
 end;

function hassuc(el:longint):boolean;
begin
 hassuc:=not( map[el]=nil);
end;

procedure getsuc(var el:pstr);
 begin
  el:=map[point];
  map[point]:=el^.link;
 end;

function istailempty:boolean;
 begin
  istailempty:=ftail=nil;
 end;

procedure dijkstra();
var points:array[1..10000] of qword;
 begin
  for i1:=1 to n do
   points[i1]:=0;
  repeat
   gettail(point);
   hlp:=map[point];
   while hassuc(point) do
    begin
     getsuc(str);
     if (points[str^.dst]=0)and(point<>points[str^.dst]) then
      begin
       points[str^.dst]:=points[point]+str^.size;
       addtail(str^.dst);
      end
     else
     if (points[point]+str^.size<points[str^.dst]) then
      begin
       points[str^.dst]:=points[point]+str^.size;
       if ndx[str^.dst]=0 then addtail(str^.dst);
      end;
     end;
   map[point]:=hlp;
  until istailempty;
  max:=0;
  for i1:=1 to n do
   if max<points[i1] then
    max:=points[i1];
 end;

procedure print;
begin
 for i:=1 to n do
  begin
   hlp:=map[i];
   point:=i;
   while hassuc(i) do
    begin
     getsuc(str);
     writeln('t,',i,' sv s ',str^.dst,' dul ',str^.size);
    end;
   map[i]:=hlp;
  end;
end;

begin
 init;
{ print;}
 for i:=1 to n do
  begin
   addtail(i);
   dijkstra;
    for i1:=1 to n do
     ndx[i1]:=0;
   writeln(max);
  end;
end.
