#include <stdio.h>
#include <malloc.h>
typedef struct _edge
{
 int e;
 int w;
 struct _edge* next;
} Edge;

Edge* v[100000];
char visited[100000];
long long dist[100000];
long long b[100000];
long long c[100000];
Edge* bp[100000];
int num[100000];
int root;
int n,m;
void add_edge(int a,int b,int w)
{
 Edge* p = (Edge*)malloc(sizeof(Edge));
 p->e=b;
 p->w=w;
 p->next=v[a];
 v[a]=p;
 num[a]++;
 p = (Edge*)malloc(sizeof(Edge));
 p->e=a;
 p->w=w;
 p->next=v[b];
 v[b]=p;
 num[b]++;
}

long long dfs(int k,long long d)
{
 Edge* p;
 long long a;
 visited[k]=1;
 b[k]=0;
 c[k]=0;
 for(p=v[k];p!=NULL;p=p->next)
    if(!visited[p->e])
    {
       a=dfs(p->e,p->w + d)+p->w;
       if(a>=b[k])
       {
          c[k]=b[k];
          b[k]=a;
          bp[k]=p;
       }
       else if(a>c[k])
       {
          c[k]=a;
       }
    }
    return b[k];
}

void traverse(int k,long long x)
{
 Edge* p;
 visited[k]=0;
 dist[k]=x > b[k] ? x :b[k];
 for(p=v[k];p!=NULL;p=p->next)
    if(visited[p->e])
    {
     if(x>b[k])
       traverse(p->e,x+p->w);
     else if(bp[k]!=p)
       traverse(p->e,b[k]+p->w);
     else if(x > c[k])
       traverse(p->e,x+p->w);
     else
       traverse(p->e,c[k]+p->w);
    }
}
int main()
{
 int i,a,b,w;
 scanf("%i %i",&n,&m);
 for(i=0;i<m;i++)
 {
  scanf("%i %i %w",&a,&b,&w);
  add_edge(a,b,w);
 }
 for(root=1;num[root]==1;root++);
 dfs(root,0);
 traverse(root,0);
 for(i=1;i<=n;i++)
    printf("%lld\n",dist[i]);
 return 0;
}
