#define NDEBUG
#include <stdio.h>
#include "module.h"

int iSize = getSize();

typedef enum {vert,horz} Spliter;

int doAsk(int iX1,int iY1,int iX2,int iY2){
    ask(iX1,iX2,iY1,iY2);
}

int doAnswer(int iX,int iY){
    #ifndef NDEBUG
        printf("Answer: %d %d\n",iX,iY);
    #endif
    answer(iX,iY);
}

void find(int iX1,int iY1,int iX2,int iY2,Spliter split,int iC){
    #ifndef NDEBUG
        printf("Find: %d %d %d %d\n",iX1,iY1,iX2,iY2);
    #endif
    if (iX1==iX2 && iY1==iY2){
        doAnswer(iX1,iY1);
        return;
    }
    if (iC == (iX2-iX1+1)*(iY2-iY1+1)){
        for (int iX=iX1;iX<=iX2;iX++)
            for (int iY=iY1;iY<=iY2;iY++)
                doAnswer(iX,iY);
        return;
    }
    if (iX1 == iX2)
        split = horz;
    if (iY1 == iY2)
        split == vert;
    if (split == horz){
        int iY = (iY1+iY2)/2;
        int iCurC = doAsk(iX1,iY1,iX2,iY);

        if (iCurC > 0)
            find(iX1,iY1,iX2,iY,vert,iCurC);

        if (iC - iCurC > 0)
            find(iX1,iY+1,iX2,iY2,vert,iC - iCurC);
    }
    if (split == vert){
        int iX = (iX1+iX2)/2;
        int iCurC = doAsk(iX1,iY1,iX,iY2);

        if (iCurC > 0)
            find(iX1,iY1,iX,iY2,horz,iCurC);

        if (iC - iCurC > 0)
            find(iX+1,iY1,iX2,iY2,horz,iC - iCurC);
    }
}

void doFind(){
    if (iSize == 1){
        doAnswer(1,1);
        return;
    }
    int iY = iSize / 2;
    int iCurC = doAsk(1,1,iSize,iY);
    int iC = doAsk(1,1,iSize,iSize);

    if (iCurC > 0)
        find(1,1,iSize,iY,vert,iCurC);

    if (iC - iCurC > 0)
        find(1,iY+1,iSize,iSize,vert,iC - iCurC);
}

int main(){
    doFind();

    return 0;
}
