#include <stdio.h>
#include <string.h>

const int MAX_DIFF = 5000;
const int MAX_C    = 10;

int iCount;
int iMax;
int iDiff;
int iSol[MAX_C][MAX_DIFF];   //iSolCount[iElementCount][iDiff];
bool bSolved[MAX_C][MAX_DIFF];

void load(){
    memset(bSolved,0,sizeof(bSolved));
    scanf("%d%d%d",&iCount,&iMax,&iDiff);
}

bool isSolved(int iC,int iD){
    return bSolved[iC][2000+iD];
}

int get(int iC,int iD){
    return iSol[iC][2000+iD];
}

void solve(int iC,int iD,int iVal){
    bSolved[iC][2000+iD] = true;
    iSol[iC][2000+iD] = iVal;
}

int find(int iC,int iD){
    if (isSolved(iC,iD))
        return get(iC,iD);
    if (iC == 0){
        if (iD == 0)
            return 1;
        else
            return 0;
    }
    int iR = 0;
    for (int iFirst=0;iFirst<=iMax;iFirst++)
        for (int iLast=0;iLast<=iMax;iLast++)
            iR += find(iC-1,iD - (iFirst - iLast));
    solve(iC,iD,iR);
    return iR;
}

int solve(){
    return find(iCount,iDiff);
}

void save(int iR){
    printf("%d\n",iR);
}

int main(){
    load();
    save(solve());

    return 0;
}
