#include <cstdio>
#include <iostream>

int ftable [10][10];

int gtable[101][10];

int gsum(int col, int from, int to)
{
	int f = 0;
	for (int i = from; i <= to; i++)
		f += gtable[i][col];
	return f;
}

void initf()
{
	for (int i = 0; i < 10; i++)
	{
		ftable[0][i] = 1;
		ftable[i][0] = 0;
		ftable[i][1] = 1;
	}

	for (int i = 1; i < 10; i++)
		for (int j = 2; j < 10; j++)
			ftable[i][j] = ftable[i-1][j] + ftable[i][j-1];
}

void initg(int l)
{
	for (int i = 0; i < 101; i++)
		gtable[i][0] = 0;

	for (int i = 0; i <= l; i++)
		for (int j = 0; j < 10; j++)
			gtable[i][j] = ftable[i][j];

	for (int i = l+1; i < 101; i++)
		for (int j = 1; j < 10; j++)
			gtable[i][j] = gsum(j-1, i-l, i);
}


int main()
{
	int n, p, k;
	std::scanf("%d %d %d", &n, &p, &k);
	initf();
	initg(p);
	long long unsigned int s = 0;
	for (int i = 0; i <= n*p-k; i++)
		s += gtable[i][n]*gtable[i+k][n];

	std::cout << s << '\n';

	return 0;
}
