#include<stdio.h>
#define MAXDIG
#define MOD 100000000

int F[10][100][MAXDIG];

void init(int a[])
{
        int i;
        for(i=0;i<MAXDIG;i++) a[i]=0;
}

void take(int a[],long long b)
{
        int i,c;
        init(a);
        for(i=1;b>0;i++)
        {
                a[MAXDIG-i]=b%MOD;
                b/=MOD;
        }
}

int br_dig(int a)
{
        int c=0;
        if(!a) return 1;
        while(a>0)
        {
               c++;
               a/=10;
        }
        return c;
}

/*int br_dig2(long long b)
{
        int c=0;
        while(b>0)
        {
                c++;
                b>>=1;
        }
        return c;
}*/

/*long long pow_2(int a)
{
        return 1<<a;
}*/

int dev2(int a[])
{
        int i,tmp;
        tmp=0;
        for(i=0;i<MAXDIG;i++)
        {
             if(tmp) a[i]+=MOD;
             tmp=a[i]%2;
             a[i]>>=1;
        }
        return tmp;
}

void mult2(int a[])
{
        int tmp=0,i;
        for(i=MAXDIG-1;i>=0;i--)
        {
                if(tmp) a[i]++;
                a[i]<<=1;
                tmp=a[i]/MOD;
                a[i]=a[i]%MOD;
        }
}

void add(int a[],int b[])
{
        int i,ost=0;
        for(i=MAXDIG-1;i>=0;i--)
        {
                a[i]=a[i]+b[i]+ost;
                ost=a[i]/MOD;
                a[i]=a[i]%MOD;
        }
}

void copy(int a[],int b[])
{
       int i;
       for(i=0;i<MAXDIG;i++)
       {
                b[i]=a[i];
       }
}

void mult(int a[],int b[],int res[])
{
        int i,c,mas[1000],r[MAXDIG];
        init(res);
        copy(b,r);
        for(i=999;i>=0;i--) mas[i]=dev2(r);
        for(i=0;i<1000;i++)
        {
                mult2(res);
                if(mas[i]) add(res,a);
        }
}

void print(int a[])
{
        int i,j,flg=0,c;
        for(i=0;i<MAXDIG;i++)
        {
                if(flg)
                {
                        c=8-br_dig(a[i]);
                        for(j=0;j<c;j++) printf("0");
                        printf("%d",a[i]);
                }
                else
                {
                        if(a[i])
                        {
                                printf("%d",a[i]);
                                flg=1;
                        }
                }
        }
        if(flg==0) printf("0");
        printf("\n");
}

void fill(int p)
{
        int i,j,l;
        //long long max=0;
        for(i=0;i<10;i++) take(F[i][0],1);
        for(i=0;i<=p;i++) take(F[1][i],1);
        for(i=2;i<10;i++)
        {
                for(j=1;j<100;j++)
                {
                        init(F[i][j]);
                        for(l=0;l<=p&&l<=j;l++) add(F[i][j],F[i-1][j-l]);
                        //if(F[i][j]>max) max=F[i][j];
                }
        }
        //printf("%lld\n",max);
}

int main()
{
        int n,p,k,i;
        //long long result=0;
        int res[MAXDIG],m[MAXDIG],vr[MAXDIG];
        scanf("%d%d%d",&n,&p,&k);
        fill(p);
        init(res);
        for(i=k;i<=n*p;i++)
        {
                mult(F[n][i],F[n][i-k],vr);
                add(res,vr);
        }
        print(res);
        //printf("%lld",F[9][99]);
        //init(b);
        //a[MAXDIG-2]=123;
        //mult2(a);
        //print(a);
        //scanf("%d",a[0]);
        return 0;
}
