#include <stdio.h>

#define MAXN    20
#define MAXK    500
#define HALFK   250

long n, p, k;
long long save[MAXN][MAXK];

long long recurse(long left, long diff)
{
   long i, j;
   long long res;

   if(left==0)
   {
     if(diff==k) return 1;
     return 0;
   }

   if(save[left][diff+HALFK]) return save[left][diff+HALFK]-1;

   res=1;

   for(i=0; i<=p; i++)
      for(j=0; j<=p; j++)
      {
         res+=recurse(left-1, diff-(i-j));
      }

   save[left][diff+HALFK]=res;

   return save[left][diff+HALFK]-1;
}


int main()
{
   long i;

   scanf("%ld%ld%ld", &n, &p, &k);

   printf("%lld\n", recurse(n, 0));

   return 0;
}

